<?php
/**
 * @file
 * //Contains \Drupal\sticky_sharrre_bar\Controller\StickySharrreBarController.
 */

namespace Drupal\sticky_sharrre_bar\Controller;

use Drupal\Component\Utility\Html;
use Symfony\Component\HttpFoundation\JsonResponse;

/**
 * Controller routines for Sticky Sharrre Bar route.
 */
class StickySharrreBarController {
  /**
   * Emulation functional of php file from http://sharrre.com.
   *
   * @return array
   *   A render array representing the administrative page content.
   */
  public function sharrre() {
    $url = $_GET['url'];
    $type = $_GET['type'];
    $output = array('url' => $url, 'count' => 0);

    \Drupal::service('page_cache_kill_switch')->trigger();

    if (filter_var($url, FILTER_VALIDATE_URL)) {
      if ($type == 'googlePlus') {
        $data = $this->stickySharrreBarParse('https://plusone.google.com/u/0/_/+1/fastbutton?url=' . $url . '&count=true');

        $dom = new \DOMDocument();
        $dom->preserveWhiteSpace = FALSE;
        @$dom->loadHTML($data);
        $dom_xpath = new \DOMXPath($dom);
        $new_dom = new \DOMDocument();
        $new_dom->formatOutput = TRUE;

        $filtered = $dom_xpath->query('//div[@id="aggregateCount"]');
        if (isset($filtered->item(0)->nodeValue)) {
          $output['count'] = $filtered->item(0)->nodeValue;
        }
      }
      else {
        if ($type == 'stumbleupon') {
          $result = $this->stickySharrreBarParse('http://www.stumbleupon.com/services/1.01/badge.getinfo?url=' . $url);
          $result = json_decode($result);

          if (isset($result->result->views)) {
            $output['count'] = Html::escape($result->result->views);
          }
        }
      }
    }

    return new JsonResponse($output);
  }

  /**
   * Get necessary content use cURL.
   *
   * @param string $encoded_url
   *   Url of page.
   *
   * @return string
   *   Ready data
   */
  private function stickySharrreBarParse($encoded_url) {
    $options = array(
      CURLOPT_RETURNTRANSFER => TRUE,
      CURLOPT_HEADER => FALSE,
      CURLOPT_FOLLOWLOCATION => TRUE,
      CURLOPT_ENCODING => '',
      CURLOPT_USERAGENT => 'sharrre',
      CURLOPT_AUTOREFERER => TRUE,
      CURLOPT_CONNECTTIMEOUT => 5,
      CURLOPT_TIMEOUT => 10,
      CURLOPT_MAXREDIRS => 3,
      CURLOPT_SSL_VERIFYHOST => 0,
      CURLOPT_SSL_VERIFYPEER => FALSE,
    );
    $curl = curl_init();

    $options[CURLOPT_URL] = $encoded_url;
    curl_setopt_array($curl, $options);
    $data = curl_exec($curl);

    curl_close($curl);

    return $data;
  }
}
